<?php

/**
 *  Implementation of hook_views_tables()
 */
/*

function media_attach_views_tables() {
  $tables['media_attachments'] = array(
    'name' => 'media_attachments',
    'join' => array(
      'left' => array(
        'table' => 'node',
        'field' => 'nid',
      ),
      'right' => array(
        'field' => 'nid',
      ),
    ),
  );

  foreach (media_type_list() as $type) {
    // allows for the presentation of specific types
    $tables['media_attachments']['fields'][$type] = array(
      'name' => t('Attached Media: !type', array('!type' => $type)),
      'handler' => _media_attach_views_field_type_handlers($type),
      'option' => array('#type' => 'select', '#options' => _media_attach_views_fields_derivatives($type)),
      'notafield' => true,
      'help' => t('This presents the first listed attached %type, according the method of display.', array('%type' => $type)),
    );
  }

  foreach (media_metadata_used() as $meta) {
    $tables['media_attachments']['fields']['meta-'. $meta] = array(
      'name' => t('Attached Media - Metadata: !meta', array('!meta' => $meta)),
      'handler' => array('_media_attach_fmh' => t('Value')),
      'notafield' => true,
      'help' => t('This displays the metadata for %meta.', array('%meta' => $meta)),
    );
  }

  return $tables;
}

function _media_attach_views_field_type_handlers($type) {
  // this should provide both simple display, display with download link, or download link.
  // caption, no caption

  return array(
    '_media_attach_fth_dp'       => t('Display'),
    '_media_attach_fth_cp'       => t('Caption'),
    '_media_attach_fth_dl'       => t('Download Link'),
    '_media_attach_fth_dp_dl'    => t('Display & Download Link'),
    '_media_attach_fth_dp_cp'    => t('Display & Caption'),
    '_media_attach_fth_cp_dp'    => t('Caption & Display'),
    '_media_attach_fth_cp_dl'    => t('Caption & Download Link'),
    '_media_attach_fth_dp_cp_dl' => t('Display, Caption & Download Link'),
    '_media_attach_fth_cp_dp_dl' => t('Caption, Display & Download Link'),
  );
}

function _media_attach_fth_dp($fieldinfo, $fielddata, $value, $data) {
  return _media_attach_fth($fieldinfo, $fielddata, $value, $data, array('dp'));
}

function _media_attach_fth_cp($fieldinfo, $fielddata, $value, $data) {
  return _media_attach_fth($fieldinfo, $fielddata, $value, $data, array('cp'));
}

function _media_attach_fth_dl($fieldinfo, $fielddata, $value, $data) {
  return _media_attach_fth($fieldinfo, $fielddata, $value, $data, array('dl'));
}

function _media_attach_fth_dp_dl($fieldinfo, $fielddata, $value, $data) {
  return _media_attach_fth($fieldinfo, $fielddata, $value, $data, array('dp', 'dl'));
}

function _media_attach_fth_dp_cp($fieldinfo, $fielddata, $value, $data) {
  return _media_attach_fth($fieldinfo, $fielddata, $value, $data, array('dp', 'cp'));
}

function _media_attach_fth_cp_dp($fieldinfo, $fielddata, $value, $data) {
  return _media_attach_fth($fieldinfo, $fielddata, $value, $data, array('cp', 'dp'));
}

function _media_attach_fth_dp_cp_dl($fieldinfo, $fielddata, $value, $data) {
  return _media_attach_fth($fieldinfo, $fielddata, $value, $data, array('dp', 'cp', 'dl'));
}

function _media_attach_fth_cp_dp_dl($fieldinfo, $fielddata, $value, $data) {
  return _media_attach_fth($fieldinfo, $fielddata, $value, $data, array('cp', 'dp', 'dl'));
}

function _media_attach_fth($fieldinfo, $fielddata, $value, $data, $order) {
  $output = '';

  $node = node_load($data->nid);
  if (!empty($node->media)) {
    $item = null;

    // what type are we looking for?
    $type = $fielddata['field'];
    $items = media_item_find("style = '%s' AND mid IN (". implode(', ', array_keys($node->media)) .")", '', array($type));
    foreach (array_keys($node->media) as $mid) {
      if (!in_array($mid, $items)) {
        continue;
      }

      $media = $node->media[$mid];

      // anything which is visible or default
      if ($media->visible || ($media->flags & MEDIA_ATTACH_DEFAULT)) {
        $item = $media;
        break;
      }
    }

    if ($item) {
      // this is the filename for which to download
      $mid = $item->mid;
      $name = $fielddata['options'];
      $filename = media_derive($mid, $name);

      foreach ($order as $op) {
        switch ($op) {
          case 'cp': // caption
            $output .= theme('media_attach_caption', $item->caption);
            break;
          case 'dp': // display
            $output .= theme('media_attach_display', media_display($filename));
            break;
          case 'dl': // download
            $output .= theme('media_attach_download', l(basename($filename), $filename));
            break;
        }
      }
    }
  }

  return $output;
}

function _media_attach_views_fields_derivatives($type) {
  // this returns a list of valid derivatives for the type
  // get list of derivatives available
  $list = array();
  if (module_exists('media_derivatives')) {
    foreach (media_type_extensions($type) as $ext) {
      foreach (media_derivatives_by_ext($ext) as $name) {
        $list[$name] = t($name);
      }
    }
    ksort($list);
  }

  // put original at front
  $list = array_merge(array('original' => t('Original')), $list);

  return $list;
}

function _media_attach_fmh($fieldinfo, $fielddata, $value, $data) {
  return '';
}

*/

/**
 *  Implementation of hook_views_style_plugins()
 */
/*

function media_attach_views_style_plugins() {
}


function theme_media_attach_caption($caption) {
  return '<div class="attach-caption">'. $caption .'</div>';
}

function theme_media_attach_download($link) {
  return '<div class="attach-link">'. $link .'</div>';
}

function theme_media_attach_display($display) {
  return '<div class="attach-display">'. $display .'</div>';
}
*/